require_dependency "dropbox_ext/application_controller"

module DropboxExt
  class DropboxController < ApplicationController

    def dropbox_redirect
      DropboxExt.mount_url + "/auth_redirect"
    end

    def dropbox_link
      @dropbox_link = "https://www.dropbox.com/1/oauth2/authorize?client_id=#{DropboxExt.db_client_id}&response_type=code&redirect_uri=" + dropbox_redirect
    end

    def index
      session["redirect_url"] = params[:redirect_url]
      @dropbox_link = dropbox_link
      redirect_to @dropbox_link
    end

    def auth_complete
      code = params[:code]

      result = DropboxHelper.get_access_key(code, dropbox_redirect)
      if result[:error]
        redirect_to "#{DropboxExt.mount_url}/?secret_url=error"
      else
        @secret_url = CGI.escape("#{DropboxExt.mount_url}/items/sync?dbt=#{result[:token]}&type=sf")
        redirect_to "#{session["redirect_url"]}&dropbox_secret_url=#{@secret_url}"
      end
    end

  end
end
